.. _mux:

#################
Multiplexer (mux)
#################

The Mux component is a generic multiplexer. It is possible to configure:

* The number of vectors
* The vector size
* The “type” of vector

The following picture shows a representation of this component.

.. figure:: _pictures/multiplexer.png
  :name: _fig-multiplexer
  :alt: Multiplexer
  :align: center

  Multiplexer overview


The command to load it is the following:

.. code-block:: shell

	halcmd load mux name=<NAME> type=<HAL TYPE>  vector_nr=<NUMBER OF VECTORS> vector_size=<VECTORS SIZE>

Where the parameters are:

* (optional) name: The multiplexer name. It is used in  the PINs name. If it is
  not set, the name is the mux instance number
* Type: The type of the PINs. It can be one of the following values: ``bit``,
  ``float``, ``signed`` or ``unsigned`` (it corresponds to the supported HAL
  types).
* (optional) vector_nr: Number of vectors. The default value is 2 which also is
  the minimum value
* (optional) vector_size: The size of the vector (the number of elements in the
  vector). The default value is 1 which also is the minimum value

It is also possible to load multiple ``mux`` components with different configurations
(the name has to be unique).

*****************
HAL PINS & params
*****************

The PIN are build as the following:

* NAME: the name passed to the load command or the multiplexer instance number.
* M: the vector number, 0 to vector_nr -1
* N: Index in the vector set, 0 to vector_size - 1

======================= ========= ========= ====================================
Name                    Type      Direction Description
======================= ========= ========= ====================================
mux.NAME.selector       HAL_U32   HAL_IN    It selects which input vector is
                                            copied to the output vector (range:
                                            0 to  vector_nr - 1). No action if
                                            its value is out of range.
mux.NAME.vectorM.inputN TYPE      HAL_IN    Input values.
mux.NAME.outputN        TYPE      HAL_OUT   Output values
======================= ========= ========= ====================================

*******
Example
*******

Here is an example on how to use this Multiplexer component.

On a 3 axes milling machine, the target position may be generated by a
Profile-Generator in Jog mode or a Path-Planner in machining (G-Code) mode. The
Multiplexer is used to select the target position source to send to the Motor Controller.

The following image illustrates this use-case.

.. figure:: _pictures/multiplexer_example.png
  :name: _fig-multiplexer_example
  :alt: Multiplexer
  :align: center

  Multiplexer example

To comply with these requirements, the multiplexer should be set up with the following
parameters:

* Number of vectors: 2
  One vector input from the Path-Planner and one vector input from the Profile Generator
* Size of the vector: 3
  As it is a 3 axes milling machine, a set-point is composed of 3 values
* PINs type: float
* Name: position
  Providing a name helps to document the use of the multiplexer (optional)

The command to load such multiplexer is the following:

.. code-block:: shell

  $ halcmd load mux name=position type=float vector_nr=2 vector_size=3

It creates the following PINs:

* ``mux.position.selector``
* ``mux.position.vector0.input{012}``
* ``mux.position.vector1.input{012}``
* ``mux.position.output{012}``

Now it is possible to connect the outputs of the *Path Planer* to the ``mux.position.vector0.input{012}``
PINs and the output of the *Profile Generator* to ``mux.position.vector1.input{012}``
PINs. The multiplexer output, ``mux.position.output{012}`` PINs, is selected with
the ``mux.position.selector`` PIN.
